import java.awt.*;
import java.util.*;
import javax.swing.*;
import java.awt.event.*;

public class Visualisation extends JPanel{

        //Ein Vektor der alle vom Player gesehenen Objecte aufnehmen wird  
	private Vector visualObjectList = new Vector();
	//int faktor = 2;
	private boolean YOURSELF, PLAYERS, BALL, FLAGS;

	//Konstruktor	
	public Visualisation(int unum, boolean YOURSELF, boolean PLAYERS, boolean BALL, boolean FLAGS){

	  setVisible(true);
	  
	}
	
	
	//Beginn einer Schleife die saemtliche Objekte aus visualObjectList aufzeichnet
	public void paintComponent(Graphics g){

		super.paintComponent(g);
	//bekommt aktuelle komponentlaenge und komponenthhe 
         	int currentWidth = getWidth();
    	  	int currentHeight = getHeight(); 
     //verschieben des Ursprungpunkt(0,0) zu (currentWidth/2,currentHeight/2)
		g.translate(currentWidth/2,currentHeight/2);
     //Verhaeltnis von aktueller ComponentsLaenge und ComponentsHhe zu Laenge und Hhe 
     //die von Server angegeben werden                
		int vx = (int)((currentWidth/2)/57);
		int vy = (int)((currentHeight/2)/39);
		
		
		
		//System.out.println(vx);
		
		g.setColor(Color.green.darker());

		//die gruene wiese
		g.fillRect(-57*vx,-39*vy,vx*115,vy*78);
		
		g.setColor(Color.white);
		//outer box
		g.drawRect((-57*vx),(vy*-39),(vx*115),(vy*78));
		//inner box
		g.drawRect(-52*vx,-34*vy,104*vx,68*vy);
		//central circle
		g.drawOval(-9*vx,-9*vy,18*vx,18*vy);
		//Mittellinie
		g.drawLine(0,(vy*-34),0,(vy*34));
		//left goal box
		g.drawRect(-52*vx,-20*vy,16*vx,40*vy);
		//right goal box
		g.drawRect(36*vx,-20*vy,16*vx,40*vy);
		//left inner goal box 
		g.drawRect(-52*vx,-9*vy,5*vx,18*vy);
		//right inner goal box
		g.drawRect(47*vx,-9*vy,5*vx,18*vy);
		
	/*	g.setColor(Color.white);
		//Legende: wird auf dem Bildschirm ausgegeben 
		g.setFont(new Font("Dialog",Font.BOLD,faktor*7));
		g.drawString("Legende:",faktor*119,faktor*154);
		//gelbes Quadrat = Ball wird auf dem Bildschirm ausgegeben
		g.setFont(new Font("Dialog",Font.BOLD,faktor*5));
		g.drawString("gelbes Quadrat = Ball",faktor*119,faktor*164);
		//schwarze Kreuze  = Flaggen wird auf dem Bildschirm ausgegeben
		g.setFont(new Font("Dialog",Font.BOLD,faktor*5));
		g.drawString("schwarze Kreuze = Flaggen",faktor*119,faktor*174);
		//blaues Quadrat = der Spieler selbst wird auf dem Bildschirm ausgegeben
		g.setFont(new Font("Dialog",Font.BOLD,faktor*5));
		g.drawString("blaues Quadrat = der Spieler selbst",faktor*119,faktor*184);
		//rote leere Punkte = Spieler des Teams wird auf dem Bildschirm ausgegeben
		g.setFont(new Font("Dialog",Font.BOLD,faktor*5));
		g.drawString("rote leere Punkte = Spieler des Teams",faktor*119,faktor*194);
	*/	
	
		
		//Jetzt werden die sichtbaren Objecte in das Feld gezeichnet
		for(Enumeration e = visualObjectList.elements(); e.hasMoreElements() ; )
		{
			ReferencePoint rp = (ReferencePoint)e.nextElement();
			double[] coord = rp.getCoord();
			switch(rp.name().charAt(0)){
				//ball
				case 'b':
				    if(BALL){
					
					g.setColor(Color.yellow);
					g.fillRect((int)((vx*(coord[0]))-(1*vx)),
						(int)((vy*(coord[1]))-(1*vy)), 3 *vx,3 *vy);
					break;
					
					}
					else break;
					
				/*case 'g':
				g.setColor(Color.black);
				g.fillOval((int)((vx*(coord[0] ))),
							(int)((vy*(coord[1]))), (int)(1*vx),(int)(1 *vy));
					break;
				*/
				
				//flag
				case 'f':
					if(FLAGS){
						g.setColor(Color.black);
						//draw a cross in black
						g.fillRect((int)((vx*(coord[0] ))-(1*vx)),
							(int)((vy*(coord[1]))), 3*vx,(1 *vy));
						g.fillRect((int)(vx*(coord[0] )),
							(int)((vy*(coord[1] ))-(1*vy)), (1 *vx),
					3 *vy);		
						break;
						
						
					}
					else break;
				
				//yourself
				case 'i':
				    if(YOURSELF){
					//draw a rectangle in blue
					g.setColor(Color.blue);
					g.fillRect((int)((vx*(coord[0]))-(1*vx)),
						(int)((vy*(coord[1]))-(1*vy)), 3 *vx, 3 *vy);
					break;
					  
					}
					else break;
			      
				//teammate/rival
				case 'p':
					if(PLAYERS){
						//stand up for ovals in red
						g.setColor(Color.red);
						g.drawOval((int)((vx*(coord[0]))-(1*vx)),
							(int)((vy*(coord[1] ))-(1*vy)), 3 *vx, 3*vy);
						break;
						
  						
						
						}
						
					else
					     break;
		
			}		
		}
	}
	
	
	//methode um das spielfeld durch einen aufruf neu zu zeichnen
	public void draw(Vector v, boolean YOURSELF, boolean PLAYERS, boolean BALL, boolean FLAGS){
		this.visualObjectList = v;
		this.YOURSELF = YOURSELF;
		this.PLAYERS = PLAYERS;
		this.BALL = BALL;		
		this.FLAGS = FLAGS;
		
		repaint();
	}

}