import java.util.*;

//***************************************************************************************
//Here the players get their positions depending of the formation and here the strategy
//finds information, if the ball is in the active zone of each player
//***************************************************************************************

public class DataCore
{

	private int unum;
	private String spielRichtung;
	//double[] PzoneCoord = new double[4];
	double[] AzoneCoord = new double[4];
	String formation;

	//public int [] aktUnum = new int[12];
	//public int stamina = 4000;


//***************************************************************************************
//****************************Konstruktor************************************************

	public DataCore(int uniNumber, String spielRichtung, String formation)
	{

		unum = uniNumber;
		this.spielRichtung = spielRichtung;
		this.formation = formation;

	}

//****************************Ende Initialisierung und Variablendefinition***************
//***************************************************************************************


public double[] goalP(int unum)
{
	double [] goalPos = new double[2];

	if(formation.equals("off"))
	{

		switch (unum)
		{
			case 9 :
				goalPos[0] = -1.0;
				goalPos[1] = -22.0;
				break;

			case 10 :

				goalPos[0] = -1.0;
				goalPos[1] = +22.0;
				break;

			case 11 :
				goalPos[0] = -1.0;
				goalPos[1] = +24.0;
				break;

		}


	}
	else  //formation is defensive
	{
		switch (unum)
		{
			case 10 :
				goalPos[0] = -1.0;
				goalPos[1] = -17.0;
				break;

		}
	}

	if(spielRichtung.charAt(0) == 'r')
	{
		return goalPos;
	}
	//es geht von rechts nach links => invertiere x-werte
	else
	{
		goalPos[0] = -(goalPos[0]);
		return goalPos;
	}
}



//***************************************************************************************
//****************************METHODEN - Definition**************************************
//***************************************************************************************
//****************************Ausgabe - Anfangsposition**********************************

	public double[] startingP(int unum)
	{
		double [] startPos = new double[2];

			if(formation.equals("def"))
			{

				switch (unum)
				{
					case 1 :
						startPos[0] = -51.5;
						startPos[1] = -0.0;
						break;

					case 2 :

						startPos[0] = -39.0;
						startPos[1] = -24.0;
						break;

					case 3 :
						startPos[0] = -39.0;
						startPos[1] = -8.0;
						break;

					case 4 :
						startPos[0] = -39.0;
						startPos[1] = +8.0;
						break;

					case 5 :
						startPos[0] = -39.0;
						startPos[1] = +24.5;
						break;

					case 6 :
						startPos[0] = -14.75;
						startPos[1] = -21.5;
						break;

					case 7 :
						startPos[0] = -12.0;
						startPos[1] = -0.0;
						break;

					case 8 :
						startPos[0] = -14.75;
						startPos[1] = +21.5;
						break;

					case 9 :
						startPos[0] = -3.0;
						startPos[1] = -25.5;
						break;

					case 10 :
						startPos[0] = -10.0;
						startPos[1] = -0.0;
						break;

					case 11 :
						startPos[0] = -3.0;
						startPos[1] = +25.5;
						break;

				} //end switch


	//differenziere nach spielRichtung

				if(spielRichtung.charAt(0) == 'r')
				{
					return startPos;
				}
				//es geht von rechts nach links => invertiere x-werte
				else
				{
					startPos[0] = -(startPos[0]);
					return startPos;
				}

 	  		}
 	  		else  //**************//formation is offensive***************************************
 	  		{
				switch (unum)
				{

					case 1 :

						startPos[0] = -45.0;
						startPos[1] = -4.0;
						break;

					case 2 :
						startPos[0] = -45.0;
						startPos[1] = +4.0;
						break;

					case 3 :
						startPos[0] = -23.0;
						startPos[1] = -14.0;
						break;

					case 4 :
						startPos[0] = -37.0;
						startPos[1] = -0.0;
						break;

					case 5 :
						startPos[0] = -23.0;
						startPos[1] = +14.0;
						break;

					case 6 :
						startPos[0] = -5.0;
						startPos[1] = -20.0;
						break;

					case 7 :
						startPos[0] = -10.0;
						startPos[1] = -0.0;
						break;

					case 8 :
						startPos[0] = -5.0;
						startPos[1] = +20.0;
						break;

					case 9 :
						startPos[0] = +30.0;
						startPos[1] = -17.0;
						break;

					case 10 :
						startPos[0] = +35.0;
						startPos[1] = -0.0;
						break;

					case 11 :
						startPos[0] = +30.0;
						startPos[1] = +17.0;
						break;
				} //end switch


	//differenziere nach spielRichtung

				if(spielRichtung.charAt(0) == 'r')
				{
					return startPos;
				}
				else  //es geht von rechts nach links => invertiere x-werte
				{
					startPos[0] = -(startPos[0]);
					return startPos;
				}

 	  		} // end else formation

	}  // end startingP().....



//***************************************************************************************
//****************************Zonenkoordinaten - Aktiv***********************************



	private double[] aZoneCoord(int unum)
	{
		if(formation == "off")
		{
			switch (unum)
			{
				case 1 :

					AzoneCoord[0] = -53.5;
					AzoneCoord[1] = -32.0;
					AzoneCoord[2] = -35.5;
					AzoneCoord[3] = +3.0;

					break;

				case 2 :

					AzoneCoord[0] = -53.5;
					AzoneCoord[1] = -32.0;
					AzoneCoord[2] = -3.0;
					AzoneCoord[3] = +35.5;

					break;

				case 3 :

					AzoneCoord[0] = -35.5;
					AzoneCoord[1] = -12.5;
					AzoneCoord[2] = -35.5;
					AzoneCoord[3] = +3.0;

					break;

				case 4 :

					AzoneCoord[0] = -38.5;
					AzoneCoord[1] = -17.5;
					AzoneCoord[2] = -11.0;
					AzoneCoord[3] = +11.0;

					break;

				case 5 :

					AzoneCoord[0] = -35.5;
					AzoneCoord[1] = -12.5;
					AzoneCoord[2] = -3.0;
					AzoneCoord[3] = +35.5;

					break;

				case 6 :

					AzoneCoord[0] = -15.0;
					AzoneCoord[1] = +19.5;
					AzoneCoord[2] = -35.5;
					AzoneCoord[3] = -8.0;

					break;

				case 7 :

					AzoneCoord[0] = -17.0;
					AzoneCoord[1] = +17.5;
					AzoneCoord[2] = -17.0;
					AzoneCoord[3] = +17.0;

					break;

				case 8 :

					AzoneCoord[0] = -15.0;
					AzoneCoord[1] = +19.5;
					AzoneCoord[2] = +8.0;
					AzoneCoord[3] = +35.5;

					break;

				case 9 :

					AzoneCoord[0] = +11.5;
					AzoneCoord[1] = +53.5;
					AzoneCoord[2] = -35.5;
					AzoneCoord[3] = -6.5;

					break;

				case 10 :

					AzoneCoord[0] = +15.0;
					AzoneCoord[1] = +53.5;
					AzoneCoord[2] = -14.5;
					AzoneCoord[3] = +14.5;

					break;

				case 11 :

					AzoneCoord[0] = +11.5;
					AzoneCoord[1] = +53.5;
					AzoneCoord[2] = +6.5;
					AzoneCoord[3] = +35.5;

					break;

			} //end switch

		} //end if formation
		else //formation is defensive
		{
			switch (unum)
			{
				case 1 :

					AzoneCoord[0] = -53.5;
					AzoneCoord[1] = -36.0;
					AzoneCoord[2] = -17.0;
					AzoneCoord[3] = +17.0;

					break;

				case 2 :

					AzoneCoord[0] = -53.5;
					AzoneCoord[1] = -15.5;
					AzoneCoord[2] = -35.5;
					AzoneCoord[3] = -15.0;

					break;

				case 3 :

					AzoneCoord[0] = -53.5;
					AzoneCoord[1] = -25.5;
					AzoneCoord[2] = -19.0;
					AzoneCoord[3] = +2.0;

					break;

				case 4 :

					AzoneCoord[0] = -53.5;
					AzoneCoord[1] = -25.5;
					AzoneCoord[2] = -2.0;
					AzoneCoord[3] = +19.0;

					break;

				case 5 :

					AzoneCoord[0] = -53.5;
					AzoneCoord[1] = -15.5;
					AzoneCoord[2] = +15.0;
					AzoneCoord[3] = +35.5;

					break;

				case 6 :

					AzoneCoord[0] = -29.5;
					AzoneCoord[1] = +5.0;
					AzoneCoord[2] = -35.5;
					AzoneCoord[3] = -5.0;

					break;

				case 7 :

					AzoneCoord[0] = -38.0;
					AzoneCoord[1] = +5.0;
					AzoneCoord[2] = -13.0;
					AzoneCoord[3] = +13.0;

					break;

				case 8 :

					AzoneCoord[0] = -29.5;
					AzoneCoord[1] = +5.0;
					AzoneCoord[2] = +5.0;
					AzoneCoord[3] = +35.5;

					break;

				case 9 :

					AzoneCoord[0] = -1.0;
					AzoneCoord[1] = +52.5;
					AzoneCoord[2] = -35.5;
					AzoneCoord[3] = -5.0;

					break;

				case 10 :

					AzoneCoord[0] = -1.0;
					AzoneCoord[1] = +52.5;
					AzoneCoord[2] = -10.0;
					AzoneCoord[3] = +10.0;

					break;

				case 11 :

					AzoneCoord[0] = -1.0;
					AzoneCoord[1] = +52.5;
					AzoneCoord[2] = +5.0;
					AzoneCoord[3] = +35.5;

					break;

				} //end switch
		}  //end else formation


		//differenziere nach spielRichtung
		if(spielRichtung.equals("l"))  //es geht von rechts nach links => invertiere x-werte
		{
			AzoneCoord[0] = -(AzoneCoord[0]);
			AzoneCoord[1] = -(AzoneCoord[1]);
		}

		return AzoneCoord;

	} // end aZoneCoord()


//***************************************************************************************
//**********************************Ausgabe ob Ball in Bewegungszone*********************

	public boolean inActZone (double ballcoordX, double ballcoordY)
	{
		boolean inaZone = false;

		double xA1 = aZoneCoord(unum)[0];
		double xA2 = aZoneCoord(unum)[1];
		double yAtop = aZoneCoord(unum)[2];
		double yAbot = aZoneCoord(unum)[3];

		if(spielRichtung.equals("r"))
		{
			if(ballcoordX >= xA1 && ballcoordX <= xA2
			   && ballcoordY >= yAtop && ballcoordY <= yAbot)
			{
				inaZone = true;
			}
		}
		else
		{
			if(ballcoordX <= xA1 && ballcoordX >= xA2
		       && ballcoordY >= yAtop && ballcoordY <= yAbot)
		    {
				inaZone = true;

			}
		}


		return inaZone;
	}

/*
//***************************************************************************************
//******************************************Stamina-change*******************************


	public int bestStamina(int stamina)
	{
		int bestPlayer = 0;
		int bestStamina;
		int staminas[][] = new int[12][2];
		staminas[unum][1] = stamina;


		for(int i = 1; i < 12; i++)
		{
			if(staminas[i][1] > stamina)
			{
				bestStamina = staminas[i][1];
				bestPlayer  = staminas[i][0];
			}
		}

		return bestPlayer;
	}

//***************************************************************************************
//***************************************Return of the actual number*********************
	//gibt die aktuelle uniformnummer zurck - am anfang
	//stimmt sie berein, kann sich aber wegen staminas ndern

	public int aktUnum()
	{
		return aktUnum[unum];
	}


//***************************************************************************************
//*********************NumberChange******************************************************
	//tauscht die Trikotnummern und speichert sie in dem feld aktUnum

	public void changeUnum(int stamina)
	{
		this.stamina = stamina;
		//tausch der uniformnummern
		int temp = aktUnum[unum];
		aktUnum[unum] = bestStamina(stamina);
		aktUnum[aktUnum[unum]] = temp;
	}

//***************************************************************************************
*/
}

//**********************************Ende Klasse DataCore*********************************
//***************************************************************************************


