import java.util.*;

// Diese Klasse parst alle messages, die sich auf hear information beziehen
 
 
// subclass der Klasse Event 
public class HearEvent extends Event
{

	private int time = -1;
		
	private boolean goalKickOff = false;
	
	private boolean beforeKickOff = false;
	
	private boolean playOn = false;
	
	private boolean goal = false;
	
	private String sender;
	
	private String tmpMsg,refMsg;
	
	
	//  Methode zeigt an, dass der event-Typ vom Typ HearEvent ist
    public boolean isHearEvent() 
    {
    	return true;
    }


	// gibt den Zeitpunkt des HearEvent zurueck
	public int time()
	{
		return time;
	}
	
	
	//gibt zurck ob es sich um eine KickOff Message handelt
	public boolean isBeforeKickOff()
	{
		return beforeKickOff;
	}
	
	
	//gibt zurck ob es sich um eine GoalkickOff Message handelt
	public boolean isGoalKickOff()
	{
		return goalKickOff;
	}
		
	//gibt zurck ob es sich um eine PlayOn Message handelt
	public boolean isPlayOn()
	{
		return playOn;	
	}
	
	// gibt zurck ob es sich um eine Goal Message handelt
	public boolean isGoal()
	{
		return goal;
	}
		
    // Konstruktor fr die Bildung von Instanzen der Klasse HearEvent
    // zieht die Informationen aus dem Server heraus
    // und untersucht sie nach einer "kick_off"-Message
    public HearEvent(String message)
    {
    	// () als string delimiters
        StringTokenizer	tokenizer = new StringTokenizer(message, "()");
        
        
        //System.out.println("Whole Message : " + message);
        
        tmpMsg = tokenizer.nextToken();
        //System.out.println("Ohne brackets : " + tmpMsg);
        
        // " " als String delimiters
        StringTokenizer token = new StringTokenizer(tmpMsg, " ");
                
        token.nextToken();
        
        time = Integer.parseInt(token.nextToken());
        //System.out.println("Zeit ist jetzt :" + time);        
        
        sender = token.nextToken();
        //System.out.println("Sender :" + sender);
        
        refMsg = token.nextToken();
        //System.out.println("Message lautet :" + refMsg);
        
        
    
		// Abfrage, ob es sich um eine goal message handelt
   		if(refMsg.startsWith("goal_r_") | refMsg.startsWith("goal_l_"))
		{            		 
       		//falls das hear event ein "goal" ist soll auf Positionen gemovt werden
          	goal = true;
          	//System.out.println("Es hat geklappt !!!!!!!!!!!!!!	 ");
	   	}	           	
	    else 
	    if(refMsg.startsWith("before_kick_off"))
		{            		 
       		//falls das hear event ein "before_kick_off" ist soll auf Positionen gemovt werden
          	beforeKickOff = true;
          	//System.out.println("Halbzeit !!Seitenwechsel !! ");
	   	}	  
 		
 		else
 		if(refMsg.startsWith("play_on"))
 		{
 			//falls das hear event ein "play_on" ist soll der Status auf PLAYING gesetzt werden
 			playOn = true;
 		}
 		
 		else
 		if(refMsg.startsWith("kick_off_r") || refMsg.startsWith("kick_off_l"))	
 		{
 			//falls das hear event ein "kick_off" ist soll der Status auf PLAYING gesetzt werden
 			goalKickOff = true;
 	    }
 				
 	}// end of hearEvent()
 	
}// end of class


