public class PowerClient
{

	public static void main(String args[])
	{
		
		String serverName;
		int serverPort;
		String teamName;		
		String formation = "off";
		int[] visualList = new int[11];		
		
		
		try
		{
			serverName = args[0];
			serverPort = Integer.parseInt(args[1]);
			teamName = args[2];
	
			try{
			if (args[3].startsWith("def")) //formation is offensive or it will be standard = defensive			
			{
				formation = "def";
			}
			}catch(ArrayIndexOutOfBoundsException aoobe){}
	
			if(args.length <= 3)
			{
					for(int i = 1 ; i <= 11 ; ++i)
					{										
						if(i == 1){
							Player player = new Player(serverName,serverPort,teamName,visualList,formation,true);	
							player.start();
						}
						else{
							Player player = new Player(serverName,serverPort,teamName,visualList,formation,false);
							player.start();
						}																		
					}
			}
			else if(args.length <= 4)
			{
					for(int i = 1 ; i <= 11 ; ++i)
					{										
						if(i == 1){
							Player player = new Player(serverName,serverPort,teamName,visualList,formation,true);	
							player.start();
						}
						else{
							Player player = new Player(serverName,serverPort,teamName,visualList,formation,false);
							player.start();
						}																		
					}
			}
			else
			{			
				if(args[4].charAt(0) == 'a')  //all players are visualised
				{				   					
					for(int i = 0 ; i < 11 ; ++i)
					{						
					    visualList[i] =  i+1;
					   if(i==1){ 
							Player player = new Player(serverName,serverPort,teamName,visualList,formation,true);
							player.start();
						}
						else{
							Player player = new Player(serverName,serverPort,teamName,visualList,formation,false);
							player.start();
						}																		

					}
		
				}								
				else  //only some or no players are visualised
				{			
				
					int x = 0;
			
					for(int i = 4; i < args.length; i++)
					{
											
						try
						{
							visualList[x] = Integer.parseInt(args[i]);	
							x = ++x;
						}
						catch(NumberFormatException nfe)
						{
							System.out.println("NumberFormatException!! Bitte [java PowerClient] eingeben.");
							System.exit(1);						
						} 
						
					}							
					for(int i = 1 ; i <= 11 ; ++i)
					{
						if(i == 1){
							Player player = new Player(serverName,serverPort,teamName,visualList,formation,true);
							player.start();
						}
						else{
							Player player = new Player(serverName,serverPort,teamName,visualList,formation,false);
							player.start();
						}																		
					}
								
				}
			}
		}		
		catch(ArrayIndexOutOfBoundsException aioobe)
		{			
			System.out.println("\n\n\n\nUsage:");
			System.out.println("=======\n");
			System.out.println("java PowerClient SERVERNAME SERVERPORT TEAMNAME [def || off] [a || SSSL]");
		//	System.out.println("java PowerClient SERVERNAME SERVERPORT TEAMNAME [a || SSSL]");
			System.out.println("========================================================================\n"); 
			System.out.println(" def    := For a defensive formation of the players.");
			System.out.println(" off    := For a offensive formation of the players.");
			System.out.println(" a      := use to visualise every player");
			System.out.println(" SSSL   := Sorted Space Separated List of numbers of players to be visualised.\n");
			System.out.println("==============================================================================\n");
			System.out.println(" e.g.   : java PowerClient localhost 6000 BRD def 1 3 5 11\n");	
			System.out.println(" or     : java PowerClient localhost 6000 Brazil off a\n\n\n\n");	
		//	System.out.println(" e.g.   : java PowerClient localhost 6000 BRD 1 3 5 11\n\n\n\n");	
		}		
			
	} // end main method
	
} //end class PowerClient

