import java.util.*;

/** Diese Klasse parst hear-messages
 */
 
// subclass der Klasse Event 
public class VisualEvent extends Event
{
	private int time = -1;
	private Vector objectPerceptionList = new Vector();
		
      
	public boolean isVisualEvent() 
   {
   	return true;
   }

	// gibt den Zeitpunkt des VisualEvent zurueck
	public int time(){return time;}
		
		
	public void add(ObjectPerception objectPerception){
		objectPerceptionList.add(objectPerception);
	}
	
	public Enumeration elements(){
		return objectPerceptionList.elements();
	}

   // Konstruktor fr die Bildung von Instanzen der Klasse VisualEvent
   // zieht die Informationen aus dem Server heraus
   // und speichert sie in der ObjectionPercptionList
   public VisualEvent(String message)
 	{
    	// () als string delimiters
        StringTokenizer	tokenizer = new StringTokenizer(message, "()");
			time = Integer.parseInt(tokenizer.nextToken().substring(4).trim());   
        // verarbeitet alle gesehenen Objekte 
 		while (tokenizer.hasMoreTokens())
      {
        	
      	// Feststellen des ObjektNamen
          	String code = tokenizer.nextToken();

          	// manchmal kommen messages ohne Inhalt an, deshalb ...
          	if (!code.equals(" "))
          	{
			try
          		{
          			// enthaelt Distanz und Winkel
          			String data = tokenizer.nextToken();
          		
          			// weiter zum naechsten Token / Objekt
          			tokenizer.nextToken();
	          	
			    	// um den Inhalt von data zu parsen: neuer Tokenizer mit Leerzeichen als Delimiter
					StringTokenizer st = new StringTokenizer(data, " ");
				
					// Abfrage, um was fuer ein Objekt es sich handelt
	           		switch (code.charAt(0)) 
	             	{
	            		case 'b':
	                	case 'g':
	                	case 'l':
	             		case 'f':	
	              	 	case 'p':
	              		              
	               		// Distanz und Winkel	               	
	          	     	double distance  = Double.parseDouble(st.nextToken());
	            		double direction = Double.parseDouble(st.nextToken());
													
	            	    // Bilden einer neuen ObjektInformation
	              		ObjectPerception objectPerception = 
					new ObjectPerception(time, code, distance, direction);
							this.add(objectPerception);
	        
	               		break;
	                
	            	}
	            
	     	  }	
	     	  catch(NoSuchElementException nsee)
	     	  {
	     	  	System.out.println("VISUALEVENT:wrong Token");
	     	  }
   		 	
			}// end of if
			
 		}// end of while
 				
 	}// end of visualEvent()
 	
}// end of class


